/*
 * "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
 * Ken Silverman's official web site: "http://www.advsys.net/ken"
 * See the included license file "BUILDLIC.TXT" for license info.
 * This file IS NOT A PART OF Ken Silverman's original release
 */

#ifndef _INCLUDE_A_H_
#define _INCLUDE_A_H_

#if (defined __WATCOMC__)
#error Do not include this header with Watcom C.
#endif

#ifdef __cplusplus
extern "C" {
#endif

#ifndef _MSC_VER

long mmxoverlay(void);
long sethlinesizes(long,long,long);
long setpalookupaddress(char *);
long setuphlineasm4(long,long);
long hlineasm4(long,long,long,long,long,long);
long setuprhlineasm4(long,long,long,long,long,long);
long rhlineasm4(long,long,long,long,long,long);
long setuprmhlineasm4(long,long,long,long,long,long);
long rmhlineasm4(long,long,long,long,long,long);
long setupqrhlineasm4(long,long,long,long,long,long);
long qrhlineasm4(long,long,long,long,long,long);
long setvlinebpl(long);
long fixtransluscence(long);
long prevlineasm1(long,long,long,long,long,long);
long vlineasm1(long,long,long,long,long,long);
long setuptvlineasm(long);
long tvlineasm1(long,long,long,long,long,long);
long setuptvlineasm2(long,long,long);
long tvlineasm2(long,long,long,long,long,long);
long mvlineasm1(long,long,long,long,long,long);
long setupvlineasm(long);
long vlineasm4(long,long);
long setupmvlineasm(long);
long mvlineasm4(long,long);
void setupspritevline(long,long,long,long,long,long);
void spritevline(long,long,long,long,long,long);
void msetupspritevline(long,long,long,long,long,long);
void mspritevline(long,long,long,long,long,long);
void tsetupspritevline(long,long,long,long,long,long);
void tspritevline(long,long,long,long,long,long);
long mhline(long,long,long,long,long,long);
long mhlineskipmodify(long,long,long,long,long,long);
long msethlineshift(long,long);
long thline(long,long,long,long,long,long);
long thlineskipmodify(long,long,long,long,long,long);
long tsethlineshift(long,long);
long setupslopevlin(long,long,long);
long slopevlin(long,long,long,long,long,long);
long settransnormal(void);
long settransreverse(void);
long setupdrawslab(long,long);
long drawslab(long,long,long,long,long,long);
long stretchhline(long,long,long,long,long,long);
long is_vmware_running(void);

#endif

    /* !!! This part might be better stated as "USE_ASM".  --ryan. */
#ifdef USE_I386_ASM
  long asm_mmxoverlay(void);
  long asm_sethlinesizes(long,long,long);
  long asm_setpalookupaddress(char *);
  long asm_setuphlineasm4(long,long);
  long asm_hlineasm4(long,long,long,long,long,long);
  long asm_setuprhlineasm4(long,long,long,long,long,long);
  long asm_rhlineasm4(long,long,long,long,long,long);
  long asm_setuprmhlineasm4(long,long,long,long,long,long);
  long asm_rmhlineasm4(long,long,long,long,long,long);
  long asm_setupqrhlineasm4(long,long,long,long,long,long);
  long asm_qrhlineasm4(long,long,long,long,long,long);
  long asm_setvlinebpl(long);
  long asm_fixtransluscence(long);
  long asm_prevlineasm1(long,long,long,long,long,long);
  long asm_vlineasm1(long,long,long,long,long,long);
  long asm_setuptvlineasm(long);
  long asm_tvlineasm1(long,long,long,long,long,long);
  long asm_setuptvlineasm2(long,long,long);
  long asm_tvlineasm2(long,long,long,long,long,long);
  long asm_mvlineasm1(long,long,long,long,long,long);
  long asm_setupvlineasm(long);
  long asm_vlineasm4(long,long);
  long asm_setupmvlineasm(long);
  long asm_mvlineasm4(long,long);
  void asm_setupspritevline(long,long,long,long,long,long);
  void asm_spritevline(long,long,long,long,long,long);
  void asm_msetupspritevline(long,long,long,long,long,long);
  void asm_mspritevline(long,long,long,long,long,long);
  void asm_tsetupspritevline(long,long,long,long,long,long);
  void asm_tspritevline(long,long,long,long,long,long);
  long asm_mhline(long,long,long,long,long,long);
  long asm_mhlineskipmodify(long,long,long,long,long,long);
  long asm_msethlineshift(long,long);
  long asm_thline(long,long,long,long,long,long);
  long asm_thlineskipmodify(long,long,long,long,long,long);
  long asm_tsethlineshift(long,long);
  long asm_setupslopevlin(long,long,long);
  long asm_slopevlin(long,long,long,long,long,long);
  long asm_settransnormal(void);
  long asm_settransreverse(void);
  long asm_setupdrawslab(long,long);
  long asm_drawslab(long,long,long,long,long,long);
  long asm_stretchhline(long,long,long,long,long,long);
  long asm_isvmwarerunning(void);

  /*
   * !!! I need a reference to this, for mprotect(), but the actual function
   * !!!  is never called in BUILD...just from other ASM routines. --ryan.
   */
  long asm_prohlineasm4(void);

  #if ((defined __GNUC__) && (!defined C_IDENTIFIERS_UNDERSCORED))

    long asm_mmxoverlay(void) __attribute__ ((alias ("_asm_mmxoverlay")));
    long asm_sethlinesizes(long,long,long) __attribute__ ((alias ("_asm_sethlinesizes")));
    long asm_setpalookupaddress(char *) __attribute__ ((alias ("_asm_setpalookupaddress")));
    long asm_setuphlineasm4(long,long) __attribute__ ((alias ("_asm_setuphlineasm4")));
    long asm_hlineasm4(long,long,long,long,long,long) __attribute__ ((alias ("_asm_hlineasm4")));
    long asm_setuprhlineasm4(long,long,long,long,long,long) __attribute__ ((alias ("_asm_setuprhlineasm4")));
    long asm_rhlineasm4(long,long,long,long,long,long) __attribute__ ((alias ("_asm_rhlineasm4")));
    long asm_setuprmhlineasm4(long,long,long,long,long,long) __attribute__ ((alias ("_asm_setuprmhlineasm4")));
    long asm_rmhlineasm4(long,long,long,long,long,long) __attribute__ ((alias ("_asm_rmhlineasm4")));
    long asm_setupqrhlineasm4(long,long,long,long,long,long) __attribute__ ((alias ("_asm_setupqrhlineasm4")));
    long asm_qrhlineasm4(long,long,long,long,long,long) __attribute__ ((alias ("_asm_qrhlineasm4")));
    long asm_setvlinebpl(long) __attribute__ ((alias ("_asm_setvlinebpl")));
    long asm_fixtransluscence(long) __attribute__ ((alias ("_asm_fixtransluscence")));
    long asm_prevlineasm1(long,long,long,long,long,long) __attribute__ ((alias ("_asm_prevlineasm1")));
    long asm_vlineasm1(long,long,long,long,long,long) __attribute__ ((alias ("_asm_vlineasm1")));
    long asm_setuptvlineasm(long) __attribute__ ((alias ("_asm_setuptvlineasm")));
    long asm_tvlineasm1(long,long,long,long,long,long) __attribute__ ((alias ("_asm_tvlineasm1")));
    long asm_setuptvlineasm2(long,long,long) __attribute__ ((alias ("_asm_setuptvlineasm2")));
    long asm_tvlineasm2(long,long,long,long,long,long) __attribute__ ((alias ("_asm_tvlineasm2")));
    long asm_mvlineasm1(long,long,long,long,long,long) __attribute__ ((alias ("_asm_mvlineasm1")));
    long asm_setupvlineasm(long) __attribute__ ((alias ("_asm_setupvlineasm")));
    long asm_vlineasm4(long,long) __attribute__ ((alias ("_asm_vlineasm4")));
    long asm_setupmvlineasm(long) __attribute__ ((alias ("_asm_setupmvlineasm")));
    long asm_mvlineasm4(long,long) __attribute__ ((alias ("_asm_mvlineasm4")));
    void asm_setupspritevline(long,long,long,long,long,long) __attribute__ ((alias ("_asm_setupspritevline")));
    void asm_spritevline(long,long,long,long,long,long) __attribute__ ((alias ("_asm_spritevline")));
    void asm_msetupspritevline(long,long,long,long,long,long) __attribute__ ((alias ("_asm_msetupspritevline")));
    void asm_mspritevline(long,long,long,long,long,long) __attribute__ ((alias ("_asm_mspritevline")));
    void asm_tsetupspritevline(long,long,long,long,long,long) __attribute__ ((alias ("_asm_tsetupspritevline")));
    void asm_tspritevline(long,long,long,long,long,long) __attribute__ ((alias ("_asm_tspritevline")));
    long asm_mhline(long,long,long,long,long,long) __attribute__ ((alias ("_asm_mhline")));
    long asm_mhlineskipmodify(long,long,long,long,long,long) __attribute__ ((alias ("_asm_mhlineskipmodify")));
    long asm_msethlineshift(long,long) __attribute__ ((alias ("_asm_msethlineshift")));
    long asm_thline(long,long,long,long,long,long) __attribute__ ((alias ("_asm_thline")));
    long asm_thlineskipmodify(long,long,long,long,long,long) __attribute__ ((alias ("_asm_thlineskipmodify")));
    long asm_tsethlineshift(long,long) __attribute__ ((alias ("_asm_tsethlineshift")));
    long asm_setupslopevlin(long,long,long) __attribute__ ((alias ("_asm_setupslopevlin")));
    long asm_slopevlin(long,long,long,long,long,long) __attribute__ ((alias ("_asm_slopevlin")));
    long asm_settransnormal(void) __attribute__ ((alias ("_asm_settransnormal")));
    long asm_settransreverse(void) __attribute__ ((alias ("_asm_settransreverse")));
    long asm_setupdrawslab(long,long) __attribute__ ((alias ("_asm_setupdrawslab")));
    long asm_drawslab(long,long,long,long,long,long) __attribute__ ((alias ("_asm_drawslab")));
    long asm_stretchhline(long,long,long,long,long,long) __attribute__ ((alias ("_asm_stretchhline")));
    long asm_isvmwarerunning(void) __attribute__ ((alias ("_asm_isvmwarerunning")));

    /*
	 * !!! I need a reference to this, for mprotect(), but the actual function
     * !!!  is never called in BUILD...just from other ASM routines. --ryan.
	 */
    long asm_prohlineasm4(void) __attribute__ ((alias ("_asm_prohlineasm4")));

  #endif /* ELF/GCC */

#ifdef _MSC_VER

	//
	// --- Ritualistic C Preprocesor Macro Abuse ---
	//
	// Ah the wonders of __declspec(naked) __inline.
	//
	// While the macros do not look exactly nice, it 
	// greatly simplifies things. Additionally, this
	// is all a fraction faster because it's all
	// inlined.
	//

	#define esp_i1 [esp+0x04]
	#define esp_i2 [esp+0x08]
	#define esp_i3 [esp+0x0C]
	#define esp_i4 [esp+0x10]
	#define esp_i5 [esp+0x14]
	#define esp_i6 [esp+0x18]

	#define JUMP_FUNC0(func)				\
		__declspec(naked) __inline long __cdecl func ()	\
		{									\
			__asm {							\
				__asm jmp asm_##func		\
			}								\
		}

	#define JUMP_FUNC1(func, reg1)			\
		__declspec(naked) __inline long __cdecl func (long i1)	\
		{									\
			__asm {							\
				__asm mov reg1, esp_i1		\
				__asm jmp asm_##func		\
			}								\
		}

	#define JUMP_FUNC1_X(func, type1, reg1)			\
		__declspec(naked) __inline long __cdecl func (type1 i1)	\
		{									\
			__asm {							\
				__asm mov reg1, esp_i1		\
				__asm jmp asm_##func		\
			}								\
		}

	#define JUMP_FUNC2(func, reg1, reg2)		\
		__declspec(naked) __inline long __cdecl func (long i1, long i2)	\
		{									\
			__asm {							\
				__asm mov reg1, esp_i1		\
				__asm mov reg2, esp_i2		\
				__asm jmp asm_##func		\
			}								\
		}

	#define JUMP_FUNC3(func, reg1, reg2, reg3)		\
		__declspec(naked) __inline long __cdecl func (long i1, long i2, long i3)	\
		{									\
			__asm {							\
				__asm mov reg1, esp_i1		\
				__asm mov reg2, esp_i2		\
				__asm mov reg3, esp_i3		\
				__asm jmp asm_##func		\
			}								\
		}

	#define JUMP_FUNC4(func, reg1, reg2, reg3, reg4)		\
		__declspec(naked) __inline long __cdecl func (long i1, long i2, long i3, long i4)	\
		{									\
			__asm {							\
				__asm mov reg1, esp_i1		\
				__asm mov reg2, esp_i2		\
				__asm mov reg3, esp_i3		\
				__asm mov reg4, esp_i4		\
				__asm jmp asm_##func		\
			}								\
		}

	#define JUMP_FUNC5(func, reg1, reg2, reg3, reg4, reg5)		\
		__declspec(naked) __inline long __cdecl func (long i1, long i2, long i3, long i4, long i5)	\
		{									\
			__asm {							\
				__asm mov reg1, esp_i1		\
				__asm mov reg2, esp_i2		\
				__asm mov reg3, esp_i3		\
				__asm mov reg4, esp_i4		\
				__asm mov reg5, esp_i5		\
				__asm jmp asm_##func		\
			}								\
		}

	#define JUMP_FUNC6(func, reg1, reg2, reg3, reg4, reg5, reg6)		\
		__declspec(naked) __inline long __cdecl func (long i1, long i2, long i3, long i4, long i5, long i6)	\
		{									\
			__asm {							\
				__asm mov reg1, esp_i1		\
				__asm mov reg2, esp_i2		\
				__asm mov reg3, esp_i3		\
				__asm mov reg4, esp_i4		\
				__asm mov reg5, esp_i5		\
				__asm mov reg6, esp_i6		\
				__asm jmp asm_##func		\
			}								\
		}

	#define JUMP_FUNC6_V(func, reg1, reg2, reg3, reg4, reg5, reg6)		\
		__declspec(naked) __inline void __cdecl func (long i1, long i2, long i3, long i4, long i5, long i6)	\
		{									\
			__asm {							\
				__asm mov reg1, esp_i1		\
				__asm mov reg2, esp_i2		\
				__asm mov reg3, esp_i3		\
				__asm mov reg4, esp_i4		\
				__asm mov reg5, esp_i5		\
				__asm mov reg6, esp_i6		\
				__asm jmp asm_##func		\
			}								\
		}

	__inline long is_vmware_running(void)
	{
		return 0;
	} /* is_vmware_running */

	/* #pragma aux mmxoverlay modify [eax ebx ecx edx] */
	JUMP_FUNC0(mmxoverlay);

	/* #pragma aux sethlinesizes parm [eax][ebx][ecx] */
	JUMP_FUNC3(sethlinesizes,eax,ebx,ecx)

	/* #pragma aux setpalookupaddress parm [eax] */
	JUMP_FUNC1_X(setpalookupaddress,char *,eax);

	/* #pragma aux setuphlineasm4 parm [eax][ebx] */
	JUMP_FUNC2(setuphlineasm4,eax,ebx);

	/* #pragma aux hlineasm4 parm [eax][ebx][ecx][edx][esi][edi] */
	JUMP_FUNC6(hlineasm4,eax,ebx,ecx,edx,esi,edi);

	/* #pragma aux setuprhlineasm4 parm [eax][ebx][ecx][edx][esi][edi] */
	JUMP_FUNC6(setuprhlineasm4, eax, ebx, ecx, edx, esi, edi);

	/* #pragma aux rhlineasm4 parm [eax][ebx][ecx][edx][esi][edi] */
	JUMP_FUNC6(rhlineasm4, eax, ebx, ecx, edx, esi, edi);

	/* #pragma aux setuprmhlineasm4 parm [eax][ebx][ecx][edx][esi][edi] */
	JUMP_FUNC6(setuprmhlineasm4, eax, ebx, ecx, edx, esi, edi);

	/* #pragma aux rmhlineasm4 parm [eax][ebx][ecx][edx][esi][edi] */
	JUMP_FUNC6(rmhlineasm4, eax, ebx, ecx, edx, esi, edi);

	/* #pragma aux setupqrhlineasm4 parm [eax][ebx][ecx][edx][esi][edi] */
	JUMP_FUNC6(setupqrhlineasm4, eax, ebx, ecx, edx, esi, edi);

	/* #pragma aux qrhlineasm4 parm [eax][ebx][ecx][edx][esi][edi] */
	JUMP_FUNC6(qrhlineasm4, eax, ebx, ecx, edx, esi, edi);

	/* #pragma aux setvlinebpl parm [eax] */
	JUMP_FUNC1(setvlinebpl, eax);

	/* #pragma aux fixtransluscence parm [eax] */
	JUMP_FUNC1(fixtransluscence, eax);

	/* #pragma aux prevlineasm1 parm [eax][ebx][ecx][edx][esi][edi] */
	JUMP_FUNC6(prevlineasm1, eax, ebx, ecx, edx, esi, edi);

	/* #pragma aux vlineasm1 parm [eax][ebx][ecx][edx][esi][edi] */
	JUMP_FUNC6(vlineasm1, eax, ebx, ecx, edx, esi, edi);

	/* #pragma aux setuptvlineasm parm [eax] */
	JUMP_FUNC1(setuptvlineasm, eax);

	/* #pragma aux tvlineasm1 parm [eax][ebx][ecx][edx][esi][edi] */
	JUMP_FUNC6(tvlineasm1, eax, ebx, ecx, edx, esi, edi);

	/* #pragma aux setuptvlineasm2 parm [eax][ebx][ecx] */
	JUMP_FUNC3(setuptvlineasm2, eax, ebx, ecx);

	/* #pragma aux tvlineasm2 parm [eax][ebx][ecx][edx][esi][edi] */
	JUMP_FUNC6(tvlineasm2, eax, ebx, ecx, edx, esi, edi);

	/* #pragma aux mvlineasm1 parm [eax][ebx][ecx][edx][esi][edi] */
	JUMP_FUNC6(mvlineasm1, eax, ebx, ecx, edx, esi, edi);

	/* #pragma aux setupvlineasm parm [eax] */
	JUMP_FUNC1(setupvlineasm, eax);

	/* #pragma aux vlineasm4 parm [ecx][edi] modify [eax ebx ecx edx esi edi] */
	JUMP_FUNC2(vlineasm4, ecx, edi);

	/* #pragma aux setupmvlineasm parm [eax] */
	JUMP_FUNC1(setupmvlineasm, eax);

	/* #pragma aux mvlineasm4 parm [ecx][edi] modify [eax ebx ecx edx esi edi] */
	JUMP_FUNC2(mvlineasm4, ecx, edi);

	/* #pragma aux setupspritevline parm [eax][ebx][ecx][edx][esi][edi] */
	JUMP_FUNC6_V(setupspritevline, eax, ebx, ecx, edx, esi, edi);
	
	/* #pragma aux spritevline parm [eax][ebx][ecx][edx][esi][edi] */
	JUMP_FUNC6_V(spritevline, eax, ebx, ecx, edx, esi, edi);

	/* #pragma aux msetupspritevline parm [eax][ebx][ecx][edx][esi][edi] */
	JUMP_FUNC6_V(msetupspritevline, eax, ebx, ecx, edx, esi, edi);

	/* #pragma aux mspritevline parm [eax][ebx][ecx][edx][esi][edi] */
	JUMP_FUNC6_V(mspritevline, eax, ebx, ecx, edx, esi, edi);

	/* #pragma aux tsetupspritevline parm [eax][ebx][ecx][edx][esi][edi] */
	JUMP_FUNC6_V(tsetupspritevline, eax, ebx, ecx, edx, esi, edi);

	/* #pragma aux tspritevline parm [eax][ebx][ecx][edx][esi][edi] */
	JUMP_FUNC6_V(tspritevline, eax, ebx, ecx, edx, esi, edi);

	/* #pragma aux mhline parm [eax][ebx][ecx][edx][esi][edi] */
	JUMP_FUNC6(mhline, eax, ebx, ecx, edx, esi, edi);

	/* #pragma aux mhlineskipmodify parm [eax][ebx][ecx][edx][esi][edi] */
	JUMP_FUNC6(mhlineskipmodify, eax, ebx, ecx, edx, esi, edi);

	/* #pragma aux msethlineshift parm [eax][ebx] */
	JUMP_FUNC2(msethlineshift, eax, ebx);

	/* #pragma aux thline parm [eax][ebx][ecx][edx][esi][edi] */
	JUMP_FUNC6(thline, eax, ebx, ecx, edx, esi, edi);

	/* #pragma aux thlineskipmodify parm [eax][ebx][ecx][edx][esi][edi] */
	JUMP_FUNC6(thlineskipmodify, eax, ebx, ecx, edx, esi, edi);

	/* #pragma aux tsethlineshift parm [eax][ebx] */
	JUMP_FUNC2(tsethlineshift, eax, ebx);

	/* #pragma aux setupslopevlin parm [eax][ebx][ecx] modify [edx] */
	JUMP_FUNC3(setupslopevlin, eax, ebx, ecx);

	/* #pragma aux slopevlin parm [eax][ebx][ecx][edx][esi][edi] */
	JUMP_FUNC6(slopevlin, eax, ebx, ecx, edx, esi, edi);

	/* #pragma aux settransnormal parm */
	JUMP_FUNC0(settransnormal);

	/* #pragma aux settransreverse parm */
	JUMP_FUNC0(settransreverse);

	/* #pragma aux setupdrawslab parm [eax][ebx] */
	JUMP_FUNC2(setupdrawslab, eax, ebx);

	/* #pragma aux drawslab parm [eax][ebx][ecx][edx][esi][edi] */
	JUMP_FUNC6(drawslab, eax, ebx, ecx, edx, esi, edi);

	/* #pragma aux stretchhline parm [eax][ebx][ecx][edx][esi][edi] */
	JUMP_FUNC6(stretchhline, eax, ebx, ecx, edx, esi, edi);


	#undef esp_i1
	#undef esp_i2
	#undef esp_i3
	#undef esp_i4
	#undef esp_i5
	#undef esp_i6
	#undef JUMP_FUNC0
	#undef JUMP_FUNC1
	#undef JUMP_FUNC1_X
	#undef JUMP_FUNC2
	#undef JUMP_FUNC3
	#undef JUMP_FUNC4
	#undef JUMP_FUNC5
	#undef JUMP_FUNC6
	#undef JUMP_FUNC6_V

#endif // _MSC_VER

#endif /* defined USE_I386_ASM */

#ifdef __cplusplus
}
#endif

#endif /* include-once-blocker. */

/* end of a.h ... */


