#ifndef _INCLUDE_PLATFORM_H_
#define _INCLUDE_PLATFORM_H_

#if (defined PLATFORM_WIN32)
#include "win32_compat.h"
#elif (defined PLATFORM_UNIX)
#include "unix_compat.h"
#elif (defined PLATFORM_DOS)
#include "doscmpat.h"
#else
#error Define your platform!
#endif

#if (!defined __EXPORT__)
#define __EXPORT__
#endif

#if ((defined PLATFORM_SUPPORTS_SDL) && (!defined PLATFORM_TIMER_HZ))
#define PLATFORM_TIMER_HZ 100
#endif

#if (!defined PLATFORM_TIMER_HZ)
#error You need to define PLATFORM_TIMER_HZ for your platform.
#endif

#if (defined __WATCOMC__)
#define snprintf _snprintf
#endif


#ifndef USE_SDL_CONBUFFER

void win32_cls( );
void win32_printchrasm(int x,int y,unsigned int ch);
void win32_printstr(short x, short y, char string[81], char attribute);
void win32_writeconbuffer(char buffer[4000]);
void w32c_FlushKeyboardQueue();
int w32c_KeyWaiting();
int w32c_GetCh();

#define _cls win32_cls
#define _writeconbuffer(buffer) win32_writeconbuffer(buffer)
#define _printstr(x,y,str,attr) win32_printstr(x,y,str,attr)
#define _printchrasm(x,y,ch) win32_printchrasm(x,y,ch)
#define _puts(str) puts(str)
#define _putchar(c) putchar(c)
#define _printf printf
#define _KB_FlushKeyboardQueue w32c_FlushKeyboardQueue
#define _KB_KeyWaiting w32c_KeyWaiting
#define _KB_Getch w32c_GetCh

#else

void _sdl_cls( );
void _sdl_writeconbuffer(char buffer[4000]);
void _sdl_printstr(short x, short y, char string[81], char attribute);
void _sdl_printchrasm(int x,int y,unsigned int ch);
int _sdl_puts(const char *str);
int _sdl_putchar(char c);
int _sdl_printf(const char *fmt, ...);

#define _cls() _sdl_cls
#define _writeconbuffer(buffer) _sdl_writeconbuffer(buffer)
#define _printstr(x,y,str,attr) _sdl_printstr(x,y,str,attr)
#define _printchrasm(x,y,ch) _sdl_printchrasm(x,y,ch)
#define _puts(str) _sdl_puts(str)
#define _putchar(c) _sdl_putchar(c)
#define _printf _sdl_printf
#define _KB_FlushKeyboardQueue KB_FlushKeyboardQueue
#define _KB_KeyWaiting KB_KeyWaiting
#define _KB_Getch KB_GetCh

#endif

#endif  /* !defined _INCLUDE_PLATFORM_H_ */

/* end of platform.h ... */


